$(() => {
let currentHouse;
window.formatCurrency = new Intl.NumberFormat('en-US', {
style: 'currency',
currency: 'USD',
minimumFractionDigits: 0,
maximumFractionDigits: 2,
}).format;
const popupOptions = {
width: 660,
height: 540,
contentTemplate() {
const result = $(_.template($('#property-details').html(), currentHouse));
const button = result.find('#favorites')
.dxButton(buttonOptions)
.dxButton('instance');
setButtonText(button, currentHouse.Favorite);
return result;
},
showTitle: true,
visible: false,
dragEnabled: false,
hideOnOutsideClick: true,
};
const buttonOptions = {
icon: 'favorites',
width: 260,
height: 44,
onClick(e) {
currentHouse.Favorite = !currentHouse.Favorite;
setButtonText(e.component, currentHouse.Favorite);
showToast(currentHouse.Favorite);
},
};
const popoverOptions = {
showEvent: 'mouseenter',
hideEvent: 'mouseleave',
width: 260,
position: {
offset: '0, 2',
at: 'bottom',
my: 'top',
collision: 'fit flip',
},
};
function showToast(favoriteState) {
const message = `This item has been ${
favoriteState ? 'added to' : 'removed from'
} the Favorites list!`;
DevExpress.ui.notify({
message,
width: 450,
}, favoriteState ? 'success' : 'error', 2000);
}
function setButtonText(button, isFav) {
button.option('text', isFav
? 'Remove from Favorites'
: 'Add to Favorites');
}
$.each(houses, (index, house) => {
const template = $(_.template($('#property-item').html())(house));
template.find(`#popover${house.ID}`)
.dxPopover($.extend(popoverOptions, {
target: `#house${house.ID}`,
}));
template.find('.item-content').on('dxclick', () => {
currentHouse = house;
$('.popup-property-details').remove();
const container = $('<div />')
.addClass('popup-property-details')
.appendTo($('#popup'));
const popup = container.dxPopup(popupOptions).dxPopup('instance');
popup.option('title', currentHouse.Address);
popup.show();
});
$('.images').append(template);
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/22.1.3/js/dx.all.js"></script>
<script src="js/underscore.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
<script src="data.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="images"></div>
<div id="popup"></div>
</div>
<script id="property-item" type="text/html">
<div>
<div class="item-content">
<img id="house-image<%= ID %>" src="<%= Image %>" />
<div class="item-options">
<div>
<div class="address"><%= Address %></div>
<div class="price large-text"><%= formatCurrency(Price) %></div>
<div class="agent">
<div id="house<%= ID %>">
<img src="images/icon-agent.svg" />
Listing agent
</div>
</div>
</div>
</div>
</div>
<div id="popover<%= ID %>">
<div class="agent-details">
<img src="<%= Agent.Picture %>" />
<div>
<div class="name large-text"><%= Agent.Name %></div>
<div class="phone">Tel: <%= Agent.Phone %></div>
</div>
</div>
</div>
</div>
</script>
<script id="property-details" type="text/html">
<div class="popup-property-details">
<div class="large-text"><%= formatCurrency(Price) %></div>
<div class="opacity"><%= Address + ", " + City + ", " + State %></div>
<div id="favorites" class="favorites"></div>
<div class="images">
<img src="<%= Image %>" />
<img src="<%= Image.replace('.jpg', 'b.jpg') %>" />
</div>
<div><%= Features %></div>
</div>
</script>
</body>
</html>
.large-text {
font-size: 24px;
color: #ff6a50;
}
.opacity {
opacity: 0.5;
}
.images {
font-size: 0;
}
.images > div {
display: inline-block;
width: 33.3%;
vertical-align: top;
}
.images .item-content {
position: relative;
margin: 5px;
color: #fff;
cursor: pointer;
}
.images .item-content > img {
width: 100%;
}
.item-content .item-options {
position: absolute;
top: 0;
left: 0;
height: 100%;
width: 100%;
}
.images .item-content:hover > .item-options {
box-shadow: inset 0 0 0 2px #f05b41;
}
.item-content .item-options > div {
position: absolute;
bottom: 0;
width: 100%;
height: 64px;
padding-top: 4px;
background-color: rgba(19, 32, 51, 0.8);
z-index: 1;
-webkit-box-sizing: border-box;
-moz-box-sizing: border-box;
box-sizing: border-box;
border-left: 2px solid transparent;
border-right: 2px solid transparent;
}
.images .item-content:hover > .item-options > div {
border-bottom: 2px solid #f05b41;
border-left: 2px solid #f05b41;
border-right: 2px solid #f05b41;
}
.item-content .item-options .address,
.item-content .item-options .price {
max-width: 70%;
padding-left: 8px;
}
.item-content .item-options .address {
font-size: 14px;
}
.item-content .item-options .agent {
font-size: 12px;
width: 60px;
position: absolute;
right: -2px;
top: 0;
bottom: 0;
text-align: center;
border-left: 1px solid rgba(255, 255, 255, 0.4);
line-height: 13px;
}
.item-content .item-options .agent > div:hover {
color: #f05b41;
}
.item-content .item-options .agent img {
display: block;
width: 13px;
height: 16px;
margin: 8px auto 2px;
}
.agent-details > img,
.agent-details > div {
display: inline-block;
vertical-align: top;
line-height: 26px;
}
.agent-details > img {
width: 40px;
margin-right: 10px;
}
.agent-details .phone {
font-size: 18px;
}
.popup-property-details {
overflow: hidden;
position: relative;
}
.popup-property-details .images {
width: 700px;
}
.popup-property-details img {
height: 205px;
margin: 10px 10px 10px 0;
}
.dx-button.favorites {
background-color: #f05b41;
color: #fff;
position: absolute;
top: 5px;
right: 0;
}
.dx-button.favorites .dx-icon {
color: #fff;
}
const houses = [{
ID: '1',
Favorite: false,
Address: '652 Avonwick Gate',
City: 'Toronto',
State: 'ON',
ZipCode: 'M3A25',
Beds: '4',
Baths: '4',
HouseSize: 7500,
LotSize: '0.8',
Price: 780000,
Coordinates: '43.7507639, -79.3184378',
Features: 'Dishwasher, Disposal, Separate laundry room, 3/4 bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Hardwood flooring in kitchen, Kitchen island, Solid surface countertops in kitchen, Entry foyer, Front living room, Ceiling fan in master bedroom, Master bedroom separate from other, Mirrored door closet in master bedroom, 2nd bedroom: 11x13, 3rd bedroom: 11x14, 4th Bedroom: 18x13, Alarm system owned, Built-in microwave, Carpet, Ceiling fan(s), Convection oven, Double built-in gas ovens, Gas cooktop, Gas stove, Marble/Stone floors',
YearBuilt: '2008',
Type: '0',
Status: '1',
Image: '../../../../images/gallery/1.jpg',
Agent: {
Name: 'John Heart',
Phone: '(213) 555-9392',
Picture: '../../../../images/employees/01.png',
},
},
{
ID: '2',
Favorite: false,
Address: '82649 Topeka St',
City: 'Riverbank',
State: 'CA',
ZipCode: '95360',
Beds: '5',
Baths: '3',
HouseSize: 12500,
LotSize: '1.2',
Price: 1750000,
Coordinates: '37.7369999,-120.9430488',
Features: 'Dishwasher, Disposal, Separate laundry room, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Pantry, Walk-in pantry, Entry foyer, Formal living room, Rear living room, Vaulted ceiling in living room, Balcony in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 13X20, 3rd bedroom: 13X17, 4th Bedroom: 13X18, 5th Bedroom: 14X16, Alarm system owned, Blinds, Built-in electric oven, Built-in microwave, Carpet, Ceiling fan(s), Gas cooktop, Intercom system, Marble/Stone floors, Water conditioner owned, Water filtering system, Window Coverings Throughout',
YearBuilt: '2009',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/2.jpg',
Agent: {
Name: 'Olivia Peyton',
Phone: '(310) 555-2728',
Picture: '../../../../images/employees/09.png',
},
},
{
ID: '3',
Favorite: false,
Address: '328 S Kerema Ave',
City: 'Milford',
State: 'CT',
ZipCode: '06465',
Beds: '4',
Baths: '2',
HouseSize: 8356,
LotSize: '0.04',
Price: 350000,
Coordinates: '41.1957999,-73.1022988',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 2nd floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Wet bar in family room, Breakfast nook (eating area), Garden window in kitchen, Granite countertops in kitchen, Kitchen island, Marble/Stone flooring in kitchen, Pantry, Formal living room, Front living room, Master bedroom separate from other, Master bedroom upstairs, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 16x12, 3rd bedroom: 13x16, 4th Bedroom: 18x12, Alarm system owned, Built-in microwave, Carpet, Ceiling fan(s), Double built-in electric ovens, Gas cooktop, Marble/Stone floors',
YearBuilt: '2010',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/3.jpg',
Agent: {
Name: 'Robert Reagan',
Phone: '(818) 555-2387',
Picture: '../../../../images/employees/03.png',
},
},
{
ID: '4',
Favorite: false,
Address: '5119 Beryl Dr',
City: 'San Antonio',
State: 'TX',
ZipCode: '78212',
Beds: '4',
Baths: '2',
HouseSize: 7980,
LotSize: '0.7',
Price: 455000,
Coordinates: '29.4972699,-98.5366788',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Living/Dining room combo, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Recessed lighting in kitchen, Tile flooring in kitchen, Walk-in pantry, Formal living room, Front living room, Ceiling fan in master bedroom, Master bedroom downstairs, Walk-in closet in master bedroom, 2nd bedroom: 15x13, 3rd bedroom: 12x12, 4th Bedroom: 14x12, Alarm system owned, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Central vacuum, Convection oven, Double built-in electric ovens, Electric cooktop, Intercom system, Tile floors',
YearBuilt: '2007',
Type: '0',
Status: '1',
Image: '../../../../images/gallery/4.jpg',
Agent: {
Name: 'Greta Sims',
Phone: '(818) 555-6546',
Picture: '../../../../images/employees/04.png',
},
},
{
ID: '5',
Favorite: false,
Address: '61207 16th St N',
City: 'Moorhead',
State: 'MN',
ZipCode: '56564',
Beds: '5',
Baths: '4',
HouseSize: 14250,
LotSize: '1.1',
Price: 1700000,
Coordinates: '46.88933,-96.7522388',
Features: 'Dishwasher, Disposal, Separate laundry room, Washer/Dryer on 1st floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Formal living room, Rear living room, Sunken living room, Vaulted ceiling in living room, Balcony in master bedroom, Ceiling fan in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Walk-in closet in master bedroom, 2nd bedroom: 16X17, 3rd bedroom: 14X16, 4th Bedroom: 13X13, 5th Bedroom: 12X12, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Central vacuum, Double built-in electric ovens, Gas cooktop, Marble/Stone floors, Pot shelves, Water conditioner owned, Water filtering system, Window Coverings Throughout',
YearBuilt: '2010',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/5.jpg',
Agent: {
Name: 'John Heart',
Phone: '(213) 555-9392',
Picture: '../../../../images/employees/01.png',
},
},
{
ID: '6',
Favorite: false,
Address: '8512 Tanglewood Cir',
City: 'Reform',
State: 'AL',
ZipCode: '35487',
Beds: '3',
Baths: '2',
HouseSize: 5600,
LotSize: '0.2',
Price: 250000,
Coordinates: '33.3794,-87.9785788',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Formal dining room, Built-in bookcases in family room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Marble/Stone flooring in kitchen, Pantry, Formal living room, Front living room, Ceiling fan in master bedroom, Master bedroom downstairs, Master bedroom separate from other, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 11X15, 3rd bedroom: 11X14, Alarm system owned, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Double built-in electric ovens, Drapes, Electric cooktop, Marble/Stone floors, Window Coverings Throughout, Wine refrigerator',
YearBuilt: '2011',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/6.jpg',
Agent: {
Name: 'Olivia Peyton',
Phone: '(310) 555-2728',
Picture: '../../../../images/employees/09.png',
},
},
{
ID: '7',
Favorite: false,
Address: '7121 Bailey St',
City: 'Worcester',
State: 'MA',
ZipCode: '01605',
Beds: '4',
Baths: '3',
HouseSize: 6900,
LotSize: '2.1',
Price: 555000,
Coordinates: '42.2797,-71.8746388',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 1st floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Kitchen island, Recessed lighting in kitchen, Tile countertops in kitchen, Walk-in pantry, Entry foyer, Formal living room, Front living room, Dressing room in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Walk-in closet in master bedroom, 2nd bedroom: 14x16, 3rd bedroom: 12x13, 4th Bedroom: 13x14, Carpet, Double built-in electric ovens, Drywall, Gas cooktop, Manmade wood or laminate floors, Marble/Stone floors, Water conditioner loope',
YearBuilt: '2008',
Type: '0',
Status: '1',
Image: '../../../../images/gallery/7.jpg',
Agent: {
Name: 'Robert Reagan',
Phone: '(818) 555-2387',
Picture: '../../../../images/employees/03.png',
},
},
{
ID: '8',
Favorite: false,
Address: '620201 Plymouth Rd',
City: 'Detroit',
State: 'MI',
ZipCode: ' 48224',
Beds: '4',
Baths: '4',
HouseSize: 7840,
LotSize: '0.33',
Price: 610000,
Coordinates: '42.3716299,-83.2572188',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Formal dining room, 2+ family rooms, Separate family room, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Walk-in pantry, Entry foyer, Formal living room, Rear living room, Vaulted ceiling in living room, Ceiling fan in master bedroom, Master bedroom downstairs, Walk-in closet in master bedroom, 2nd bedroom: 12x15, 3rd bedroom: 12x15, 4th Bedroom: 12x15, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Electric cooktop, Shutters, Skylight(s), Water conditioner owned, Water filtering system, Window coverings partial',
YearBuilt: '2010',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/8.jpg',
Agent: {
Name: 'Greta Sims',
Phone: '(818) 555-6546',
Picture: '../../../../images/employees/04.png',
},
},
{
ID: '9',
Favorite: false,
Address: '1198 Theresa Cir',
City: 'Whitinsville',
State: 'MA',
ZipCode: '01582',
Beds: '4',
Baths: '3',
HouseSize: 4990,
LotSize: '0.8',
Price: 320000,
Coordinates: '42.1072,-71.6928888',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 1st floor, 1/2 bath downstairs, Formal dining room, 2+ family rooms, Built-in bookcases in family room, Breakfast Bar/Counter, Granite countertops in kitchen, Kitchen island, Tile flooring in kitchen, Walk-in pantry, Entry foyer, Formal living room, Built-in bookcases in master bedroom, Built-in entertainment center in master bedroom, Ceiling fan in master bedroom, Dressing room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 13x12, 3rd bedroom: 12x12, 4th Bedroom: 13x12, Alarm system rented, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Double built-in gas ovens, Tile floors, Window Coverings Throughout',
YearBuilt: '2011',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/9.jpg',
Agent: {
Name: 'John Heart',
Phone: '(213) 555-9392',
Picture: '../../../../images/employees/01.png',
},
},
];

<template>
<div class="images">
<div
v-for="house in houses"
:key="house.ID"
>
<div
class="item-content"
@click="showHouse(house)"
>
<img :src="house.Image">
<div class="item-options">
<div>
<div class="address">{{ house.Address }}</div>
<div class="price large-text">{{ currency(house.Price) }}</div>
<div class="agent">
<div :id="'house' + house.ID">
<img src="../../../../images/icon-agent.svg">
Listing agent
</div>
</div>
</div>
</div>
<DxPopover
:position="position"
:target="'#house' + house.ID"
:width="260"
show-event="mouseenter"
hide-event="mouseleave"
content-template="popoverContent"
>
<template #popoverContent="{ data }">
<div class="agent-details">
<img :src="house.Agent.Picture">
<div>
<div class="name large-text">{{ house.Agent.Name }}</div>
<div class="phone">Tel: {{ house.Agent.Phone }}</div>
</div>
</div>
</template>
</DxPopover>
</div>
</div>
<DxPopup
:width="660"
:height="540"
:show-title="true"
:title="currentHouse.Address"
:drag-enabled="false"
:close-on-outside-click="true"
v-model:visible="popupVisible"
>
<template #content="{ data }">
<div class="popup-property-details">
<div class="large-text">{{ currency(currentHouse.Price) }}</div>
<div class="opacity">{{ currentHouse.Address }}, {{ currentHouse.City }}, {{ currentHouse.State }}</div>
<DxButton
:text="favoriteText"
:width="210"
:height="44"
class="favorites"
icon="favorites"
@click="changeFavoriteState"
/>
<div class="images">
<img :src="currentHouse.Image">
<img :src="currentHouse.Image.replace('.jpg', 'b.jpg')">
</div>
<div>{{ currentHouse.Features }}</div>
</div>
</template>
</DxPopup>
</div>
</template>
<script>
import DxButton from 'devextreme-vue/button';
import DxPopup from 'devextreme-vue/popup';
import DxPopover from 'devextreme-vue/popover';
import notify from 'devextreme/ui/notify';
import { housesSource } from './data.js';
const currencyFormatter = new Intl.NumberFormat('en-US', {
style: 'currency',
currency: 'USD',
minimumFractionDigits: 0,
maximumFractionDigits: 2
});
const
ADD_TO_FAVORITES = 'Add to Favorites',
REMOVE_FROM_FAVORITES = 'Remove from Favorites';
export default {
components: {
DxButton, DxPopup, DxPopover
},
data: function() {
return {
houses: housesSource,
currentHouse: housesSource[0],
popupVisible: false,
position: {
offset: '0, 2',
at: 'bottom',
my: 'top',
collision: 'fit flip'
}
};
},
computed: {
favoriteText() {
return this.currentHouse.Favorite ? REMOVE_FROM_FAVORITES : ADD_TO_FAVORITES;
}
},
methods: {
currency(val) {
return currencyFormatter.format(val);
},
showHouse(house) {
this.currentHouse = house;
this.popupVisible = true;
},
changeFavoriteState() {
let favoriteState = !this.currentHouse.Favorite;
let message = `This item has been ${
favoriteState ? 'added to' : 'removed from'
} the Favorites list!`;
this.currentHouse.Favorite = favoriteState;
notify({
message: message,
width: 450
},
favoriteState ? 'success' : 'error', 2000
);
}
}
};
</script>
<style src="./styles.css"></style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app">
</div>
</div>
</body>
</html>
.large-text {
font-size: 24px;
color: #ff6a50;
}
.opacity {
opacity: 0.5;
}
.images {
font-size: 0;
}
.images > div {
display: inline-block;
width: 33.3%;
vertical-align: top;
}
.images .item-content {
position: relative;
margin: 5px;
color: #fff;
cursor: pointer;
}
.images .item-content > img {
width: 100%;
}
.item-content .item-options {
position: absolute;
top: 0;
left: 0;
height: 100%;
width: 100%;
}
.images .item-content:hover > .item-options {
box-shadow: inset 0 0 0 2px #f05b41;
}
.item-content .item-options > div {
position: absolute;
bottom: 0;
width: 100%;
height: 64px;
padding-top: 4px;
background-color: rgba(19,32,51,0.8);
z-index: 1;
-webkit-box-sizing: border-box;
-moz-box-sizing: border-box;
box-sizing: border-box;
border-left: 2px solid transparent;
border-right: 2px solid transparent;
}
.images .item-content:hover > .item-options > div {
border-bottom: 2px solid #f05b41;
border-left: 2px solid #f05b41;
border-right: 2px solid #f05b41;
}
.item-content .item-options .address,
.item-content .item-options .price {
max-width: 70%;
padding-left: 8px;
}
.item-content .item-options .address {
font-size: 14px;
}
.item-content .item-options .agent {
font-size: 12px;
width: 60px;
position: absolute;
right: -2px;
top: 0;
bottom: 0;
text-align: center;
border-left: 1px solid rgba(255, 255, 255, 0.4);
line-height: 13px;
}
.item-content .item-options .agent > div:hover {
color: #f05b41;
}
.item-content .item-options .agent img {
display: block;
width: 13px;
height: 16px;
margin: 8px auto 2px;
}
.agent-details > img, .agent-details > div {
display: inline-block;
vertical-align: top;
line-height: 26px;
}
.agent-details > img {
width: 40px;
margin-right: 10px;
}
.agent-details .phone {
font-size: 18px;
}
.popup-property-details {
overflow: hidden;
position: relative;
}
.popup-property-details .images {
width: 700px;
}
.popup-property-details img {
height: 205px;
margin: 10px 10px 10px 0;
}
.dx-button.favorites {
background-color: #f05b41;
color: #fff;
position: absolute;
top: 5px;
right: 0;
}
.dx-button.favorites .dx-icon {
color: #fff;
}
export const housesSource = [{
ID: '1',
Favorite: false,
Address: '652 Avonwick Gate',
City: 'Toronto',
State: 'ON',
ZipCode: 'M3A25',
Beds: '4',
Baths: '4',
HouseSize: 7500,
LotSize: '0.8',
Price: 780000,
Coordinates: '43.7507639, -79.3184378',
Features: 'Dishwasher, Disposal, Separate laundry room, 3/4 bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Hardwood flooring in kitchen, Kitchen island, Solid surface countertops in kitchen, Entry foyer, Front living room, Ceiling fan in master bedroom, Master bedroom separate from other, Mirrored door closet in master bedroom, 2nd bedroom: 11x13, 3rd bedroom: 11x14, 4th Bedroom: 18x13, Alarm system owned, Built-in microwave, Carpet, Ceiling fan(s), Convection oven, Double built-in gas ovens, Gas cooktop, Gas stove, Marble/Stone floors',
YearBuilt: '2008',
Type: '0',
Status: '1',
Image: '../../../../images/gallery/1.jpg',
Agent: {
Name: 'John Heart',
Phone: '(213) 555-9392',
Picture: '../../../../images/employees/01.png'
}
},
{
ID: '2',
Favorite: false,
Address: '82649 Topeka St',
City: 'Riverbank',
State: 'CA',
ZipCode: '95360',
Beds: '5',
Baths: '3',
HouseSize: 12500,
LotSize: '1.2',
Price: 1750000,
Coordinates: '37.7369999,-120.9430488',
Features: 'Dishwasher, Disposal, Separate laundry room, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Pantry, Walk-in pantry, Entry foyer, Formal living room, Rear living room, Vaulted ceiling in living room, Balcony in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 13X20, 3rd bedroom: 13X17, 4th Bedroom: 13X18, 5th Bedroom: 14X16, Alarm system owned, Blinds, Built-in electric oven, Built-in microwave, Carpet, Ceiling fan(s), Gas cooktop, Intercom system, Marble/Stone floors, Water conditioner owned, Water filtering system, Window Coverings Throughout',
YearBuilt: '2009',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/2.jpg',
Agent: {
Name: 'Olivia Peyton',
Phone: '(310) 555-2728',
Picture: '../../../../images/employees/09.png'
}
},
{
ID: '3',
Favorite: false,
Address: '328 S Kerema Ave',
City: 'Milford',
State: 'CT',
ZipCode: '06465',
Beds: '4',
Baths: '2',
HouseSize: 8356,
LotSize: '0.04',
Price: 350000,
Coordinates: '41.1957999,-73.1022988',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 2nd floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Wet bar in family room, Breakfast nook (eating area), Garden window in kitchen, Granite countertops in kitchen, Kitchen island, Marble/Stone flooring in kitchen, Pantry, Formal living room, Front living room, Master bedroom separate from other, Master bedroom upstairs, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 16x12, 3rd bedroom: 13x16, 4th Bedroom: 18x12, Alarm system owned, Built-in microwave, Carpet, Ceiling fan(s), Double built-in electric ovens, Gas cooktop, Marble/Stone floors',
YearBuilt: '2010',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/3.jpg',
Agent: {
Name: 'Robert Reagan',
Phone: '(818) 555-2387',
Picture: '../../../../images/employees/03.png'
}
},
{
ID: '4',
Favorite: false,
Address: '5119 Beryl Dr',
City: 'San Antonio',
State: 'TX',
ZipCode: '78212',
Beds: '4',
Baths: '2',
HouseSize: 7980,
LotSize: '0.7',
Price: 455000,
Coordinates: '29.4972699,-98.5366788',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Living/Dining room combo, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Recessed lighting in kitchen, Tile flooring in kitchen, Walk-in pantry, Formal living room, Front living room, Ceiling fan in master bedroom, Master bedroom downstairs, Walk-in closet in master bedroom, 2nd bedroom: 15x13, 3rd bedroom: 12x12, 4th Bedroom: 14x12, Alarm system owned, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Central vacuum, Convection oven, Double built-in electric ovens, Electric cooktop, Intercom system, Tile floors',
YearBuilt: '2007',
Type: '0',
Status: '1',
Image: '../../../../images/gallery/4.jpg',
Agent: {
Name: 'Greta Sims',
Phone: '(818) 555-6546',
Picture: '../../../../images/employees/04.png'
}
},
{
ID: '5',
Favorite: false,
Address: '61207 16th St N',
City: 'Moorhead',
State: 'MN',
ZipCode: '56564',
Beds: '5',
Baths: '4',
HouseSize: 14250,
LotSize: '1.1',
Price: 1700000,
Coordinates: '46.88933,-96.7522388',
Features: 'Dishwasher, Disposal, Separate laundry room, Washer/Dryer on 1st floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Formal living room, Rear living room, Sunken living room, Vaulted ceiling in living room, Balcony in master bedroom, Ceiling fan in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Walk-in closet in master bedroom, 2nd bedroom: 16X17, 3rd bedroom: 14X16, 4th Bedroom: 13X13, 5th Bedroom: 12X12, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Central vacuum, Double built-in electric ovens, Gas cooktop, Marble/Stone floors, Pot shelves, Water conditioner owned, Water filtering system, Window Coverings Throughout',
YearBuilt: '2010',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/5.jpg',
Agent: {
Name: 'John Heart',
Phone: '(213) 555-9392',
Picture: '../../../../images/employees/01.png'
}
},
{
ID: '6',
Favorite: false,
Address: '8512 Tanglewood Cir',
City: 'Reform',
State: 'AL',
ZipCode: '35487',
Beds: '3',
Baths: '2',
HouseSize: 5600,
LotSize: '0.2',
Price: 250000,
Coordinates: '33.3794,-87.9785788',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Formal dining room, Built-in bookcases in family room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Marble/Stone flooring in kitchen, Pantry, Formal living room, Front living room, Ceiling fan in master bedroom, Master bedroom downstairs, Master bedroom separate from other, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 11X15, 3rd bedroom: 11X14, Alarm system owned, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Double built-in electric ovens, Drapes, Electric cooktop, Marble/Stone floors, Window Coverings Throughout, Wine refrigerator',
YearBuilt: '2011',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/6.jpg',
Agent: {
Name: 'Olivia Peyton',
Phone: '(310) 555-2728',
Picture: '../../../../images/employees/09.png'
}
},
{
ID: '7',
Favorite: false,
Address: '7121 Bailey St',
City: 'Worcester',
State: 'MA',
ZipCode: '01605',
Beds: '4',
Baths: '3',
HouseSize: 6900,
LotSize: '2.1',
Price: 555000,
Coordinates: '42.2797,-71.8746388',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 1st floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Kitchen island, Recessed lighting in kitchen, Tile countertops in kitchen, Walk-in pantry, Entry foyer, Formal living room, Front living room, Dressing room in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Walk-in closet in master bedroom, 2nd bedroom: 14x16, 3rd bedroom: 12x13, 4th Bedroom: 13x14, Carpet, Double built-in electric ovens, Drywall, Gas cooktop, Manmade wood or laminate floors, Marble/Stone floors, Water conditioner loope',
YearBuilt: '2008',
Type: '0',
Status: '1',
Image: '../../../../images/gallery/7.jpg',
Agent: {
Name: 'Robert Reagan',
Phone: '(818) 555-2387',
Picture: '../../../../images/employees/03.png'
}
},
{
ID: '8',
Favorite: false,
Address: '620201 Plymouth Rd',
City: 'Detroit',
State: 'MI',
ZipCode: ' 48224',
Beds: '4',
Baths: '4',
HouseSize: 7840,
LotSize: '0.33',
Price: 610000,
Coordinates: '42.3716299,-83.2572188',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Formal dining room, 2+ family rooms, Separate family room, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Walk-in pantry, Entry foyer, Formal living room, Rear living room, Vaulted ceiling in living room, Ceiling fan in master bedroom, Master bedroom downstairs, Walk-in closet in master bedroom, 2nd bedroom: 12x15, 3rd bedroom: 12x15, 4th Bedroom: 12x15, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Electric cooktop, Shutters, Skylight(s), Water conditioner owned, Water filtering system, Window coverings partial',
YearBuilt: '2010',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/8.jpg',
Agent: {
Name: 'Greta Sims',
Phone: '(818) 555-6546',
Picture: '../../../../images/employees/04.png'
}
},
{
ID: '9',
Favorite: false,
Address: '1198 Theresa Cir',
City: 'Whitinsville',
State: 'MA',
ZipCode: '01582',
Beds: '4',
Baths: '3',
HouseSize: 4990,
LotSize: '0.8',
Price: 320000,
Coordinates: '42.1072,-71.6928888',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 1st floor, 1/2 bath downstairs, Formal dining room, 2+ family rooms, Built-in bookcases in family room, Breakfast Bar/Counter, Granite countertops in kitchen, Kitchen island, Tile flooring in kitchen, Walk-in pantry, Entry foyer, Formal living room, Built-in bookcases in master bedroom, Built-in entertainment center in master bedroom, Ceiling fan in master bedroom, Dressing room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 13x12, 3rd bedroom: 12x12, 4th Bedroom: 13x12, Alarm system rented, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Double built-in gas ovens, Tile floors, Window Coverings Throughout',
YearBuilt: '2011',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/9.jpg',
Agent: {
Name: 'John Heart',
Phone: '(213) 555-9392',
Picture: '../../../../images/employees/01.png'
}
}
];
System.config({
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader'
},
'devextreme/localization.js': {
"esModule": true
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.5',
'devextreme-vue': 'npm:devextreme-vue@20.2.5',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.11/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.18/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.11/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.11/hooks/dist/hooks.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});

import React from 'react';
import notify from 'devextreme/ui/notify';
import Button from 'devextreme-react/button';
import Popup from 'devextreme-react/popup';
import { housesSource } from './data.js';
import House from './House.js';
const ADD_TO_FAVORITES = 'Add to Favorites';
const REMOVE_FROM_FAVORITES = 'Remove from Favorites';
const formatCurrency = new Intl.NumberFormat('en-US', {
style: 'currency',
currency: 'USD',
minimumFractionDigits: 0,
maximumFractionDigits: 2,
}).format;
const favButtonAttrs = {
class: 'favorites',
};
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
currentHouse: housesSource[0],
};
this.renderPopup = this.renderPopup.bind(this);
this.showHouse = this.showHouse.bind(this);
this.changeFavoriteState = this.changeFavoriteState.bind(this);
this.handlePopupHidden = this.handlePopupHidden.bind(this);
}
render() {
return (
<div className="images">
{
housesSource.map((h) => <House
house={h}
show={this.showHouse}
key={h.ID}
/>)
}
<Popup
width={660}
height={540}
showTitle={true}
title={this.state.currentHouse.Address}
dragEnabled={false}
hideOnOutsideClick={true}
visible={this.state.popupVisible}
onHiding={this.handlePopupHidden}
contentRender={this.renderPopup}
/>
</div>
);
}
renderPopup() {
const { currentHouse } = this.state;
return (
<div className="popup-property-details">
<div className="large-text">{formatCurrency(currentHouse.Price)}</div>
<div className="opacity">{currentHouse.Address}, {currentHouse.City}, {currentHouse.State}</div>
<Button
icon="favorites"
text={currentHouse.Favorite ? REMOVE_FROM_FAVORITES : ADD_TO_FAVORITES}
width={260}
height={44}
elementAttr={favButtonAttrs}
onClick={this.changeFavoriteState}
/>
<div className="images">
<img alt={currentHouse.Address} src={currentHouse.Image} />
<img alt={currentHouse.Address} src={currentHouse.Image.replace('.jpg', 'b.jpg')} />
</div>
<div>{currentHouse.Features}</div>
</div>
);
}
showHouse(house) {
this.setState({
currentHouse: house,
popupVisible: true,
});
}
handlePopupHidden() {
this.setState({
popupVisible: false,
});
}
changeFavoriteState() {
const { currentHouse } = this.state;
currentHouse.Favorite = !currentHouse.Favorite;
this.renderPopup = this.renderPopup.bind(this);
this.setState({
currentHouse,
});
notify({
message: `This item has been ${
currentHouse.Favorite ? 'added to' : 'removed from'
} the Favorites list!`,
width: 450,
},
currentHouse.Favorite ? 'success' : 'error', 2000);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.large-text {
font-size: 24px;
color: #ff6a50;
}
.opacity {
opacity: 0.5;
}
.images {
font-size: 0;
}
.images > div {
display: inline-block;
width: 33.3%;
vertical-align: top;
}
.images .item-content {
position: relative;
margin: 5px;
color: #fff;
cursor: pointer;
}
.images .item-content > img {
width: 100%;
}
.item-content .item-options {
position: absolute;
top: 0;
left: 0;
height: 100%;
width: 100%;
}
.images .item-content:hover > .item-options {
box-shadow: inset 0 0 0 2px #f05b41;
}
.item-content .item-options > div {
position: absolute;
bottom: 0;
width: 100%;
height: 64px;
padding-top: 4px;
background-color: rgba(19, 32, 51, 0.8);
z-index: 1;
-webkit-box-sizing: border-box;
-moz-box-sizing: border-box;
box-sizing: border-box;
border-left: 2px solid transparent;
border-right: 2px solid transparent;
}
.images .item-content:hover > .item-options > div {
border-bottom: 2px solid #f05b41;
border-left: 2px solid #f05b41;
border-right: 2px solid #f05b41;
}
.item-content .item-options .address,
.item-content .item-options .price {
max-width: 70%;
padding-left: 8px;
}
.item-content .item-options .address {
font-size: 14px;
}
.item-content .item-options .agent {
font-size: 12px;
width: 60px;
position: absolute;
right: -2px;
top: 0;
bottom: 0;
text-align: center;
border-left: 1px solid rgba(255, 255, 255, 0.4);
line-height: 13px;
}
.item-content .item-options .agent > div:hover {
color: #f05b41;
}
.item-content .item-options .agent img {
display: block;
width: 13px;
height: 16px;
margin: 8px auto 2px;
}
.agent-details > img,
.agent-details > div {
display: inline-block;
vertical-align: top;
line-height: 26px;
}
.agent-details > img {
width: 40px;
margin-right: 10px;
}
.agent-details .phone {
font-size: 18px;
}
.popup-property-details {
overflow: hidden;
position: relative;
}
.popup-property-details .images {
width: 700px;
}
.popup-property-details img {
height: 205px;
margin: 10px 10px 10px 0;
}
.dx-button.favorites {
background-color: #f05b41;
color: #fff;
position: absolute;
top: 5px;
right: 0;
}
.dx-button.favorites .dx-icon {
color: #fff;
}
import React from 'react';
import Popover from 'devextreme-react/popover';
const formatCurrency = new Intl.NumberFormat('en-US', {
style: 'currency',
currency: 'USD',
minimumFractionDigits: 0,
maximumFractionDigits: 2,
}).format;
const position = {
offset: '0, 2',
at: 'bottom',
my: 'top',
collision: 'fit flip',
};
class House extends React.PureComponent {
constructor(props) {
super(props);
this.show = this.show.bind(this);
this.renderAgentDetails = this.renderAgentDetails.bind(this);
}
render() {
const { house } = this.props;
return (
<div>
<div onClick={this.show} className="item-content">
<img alt={house.Address} src={house.Image} />
<div className="item-options">
<div>
<div className="address">{house.Address}</div>
<div className="price large-text">{formatCurrency(house.Price)}</div>
<div className="agent">
<div id={`house${house.ID}`}>
<img alt="Listing agent" src="../../../../images/icon-agent.svg" />
Listing agent
</div>
</div>
</div>
</div>
<Popover
showEvent="mouseenter"
hideEvent="mouseleave"
position={position}
target={`#house${house.ID}`}
width={260}
contentRender={this.renderAgentDetails}
/>
</div>
</div>
);
}
renderAgentDetails() {
const agent = this.props.house.Agent;
return (
<div className="agent-details">
<img alt={agent.Name} src={agent.Picture} />
<div>
<div className="name large-text">{agent.Name}</div>
<div className="phone">Tel: {agent.Phone}</div>
</div>
</div>
);
}
show() {
this.props.show(this.props.house);
}
}
export default House;
export const housesSource = [{
ID: '1',
Favorite: false,
Address: '652 Avonwick Gate',
City: 'Toronto',
State: 'ON',
ZipCode: 'M3A25',
Beds: '4',
Baths: '4',
HouseSize: 7500,
LotSize: '0.8',
Price: 780000,
Coordinates: '43.7507639, -79.3184378',
Features: 'Dishwasher, Disposal, Separate laundry room, 3/4 bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Hardwood flooring in kitchen, Kitchen island, Solid surface countertops in kitchen, Entry foyer, Front living room, Ceiling fan in master bedroom, Master bedroom separate from other, Mirrored door closet in master bedroom, 2nd bedroom: 11x13, 3rd bedroom: 11x14, 4th Bedroom: 18x13, Alarm system owned, Built-in microwave, Carpet, Ceiling fan(s), Convection oven, Double built-in gas ovens, Gas cooktop, Gas stove, Marble/Stone floors',
YearBuilt: '2008',
Type: '0',
Status: '1',
Image: '../../../../images/gallery/1.jpg',
Agent: {
Name: 'John Heart',
Phone: '(213) 555-9392',
Picture: '../../../../images/employees/01.png',
},
},
{
ID: '2',
Favorite: false,
Address: '82649 Topeka St',
City: 'Riverbank',
State: 'CA',
ZipCode: '95360',
Beds: '5',
Baths: '3',
HouseSize: 12500,
LotSize: '1.2',
Price: 1750000,
Coordinates: '37.7369999,-120.9430488',
Features: 'Dishwasher, Disposal, Separate laundry room, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Pantry, Walk-in pantry, Entry foyer, Formal living room, Rear living room, Vaulted ceiling in living room, Balcony in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 13X20, 3rd bedroom: 13X17, 4th Bedroom: 13X18, 5th Bedroom: 14X16, Alarm system owned, Blinds, Built-in electric oven, Built-in microwave, Carpet, Ceiling fan(s), Gas cooktop, Intercom system, Marble/Stone floors, Water conditioner owned, Water filtering system, Window Coverings Throughout',
YearBuilt: '2009',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/2.jpg',
Agent: {
Name: 'Olivia Peyton',
Phone: '(310) 555-2728',
Picture: '../../../../images/employees/09.png',
},
},
{
ID: '3',
Favorite: false,
Address: '328 S Kerema Ave',
City: 'Milford',
State: 'CT',
ZipCode: '06465',
Beds: '4',
Baths: '2',
HouseSize: 8356,
LotSize: '0.04',
Price: 350000,
Coordinates: '41.1957999,-73.1022988',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 2nd floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Wet bar in family room, Breakfast nook (eating area), Garden window in kitchen, Granite countertops in kitchen, Kitchen island, Marble/Stone flooring in kitchen, Pantry, Formal living room, Front living room, Master bedroom separate from other, Master bedroom upstairs, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 16x12, 3rd bedroom: 13x16, 4th Bedroom: 18x12, Alarm system owned, Built-in microwave, Carpet, Ceiling fan(s), Double built-in electric ovens, Gas cooktop, Marble/Stone floors',
YearBuilt: '2010',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/3.jpg',
Agent: {
Name: 'Robert Reagan',
Phone: '(818) 555-2387',
Picture: '../../../../images/employees/03.png',
},
},
{
ID: '4',
Favorite: false,
Address: '5119 Beryl Dr',
City: 'San Antonio',
State: 'TX',
ZipCode: '78212',
Beds: '4',
Baths: '2',
HouseSize: 7980,
LotSize: '0.7',
Price: 455000,
Coordinates: '29.4972699,-98.5366788',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Living/Dining room combo, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Recessed lighting in kitchen, Tile flooring in kitchen, Walk-in pantry, Formal living room, Front living room, Ceiling fan in master bedroom, Master bedroom downstairs, Walk-in closet in master bedroom, 2nd bedroom: 15x13, 3rd bedroom: 12x12, 4th Bedroom: 14x12, Alarm system owned, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Central vacuum, Convection oven, Double built-in electric ovens, Electric cooktop, Intercom system, Tile floors',
YearBuilt: '2007',
Type: '0',
Status: '1',
Image: '../../../../images/gallery/4.jpg',
Agent: {
Name: 'Greta Sims',
Phone: '(818) 555-6546',
Picture: '../../../../images/employees/04.png',
},
},
{
ID: '5',
Favorite: false,
Address: '61207 16th St N',
City: 'Moorhead',
State: 'MN',
ZipCode: '56564',
Beds: '5',
Baths: '4',
HouseSize: 14250,
LotSize: '1.1',
Price: 1700000,
Coordinates: '46.88933,-96.7522388',
Features: 'Dishwasher, Disposal, Separate laundry room, Washer/Dryer on 1st floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Formal living room, Rear living room, Sunken living room, Vaulted ceiling in living room, Balcony in master bedroom, Ceiling fan in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Walk-in closet in master bedroom, 2nd bedroom: 16X17, 3rd bedroom: 14X16, 4th Bedroom: 13X13, 5th Bedroom: 12X12, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Central vacuum, Double built-in electric ovens, Gas cooktop, Marble/Stone floors, Pot shelves, Water conditioner owned, Water filtering system, Window Coverings Throughout',
YearBuilt: '2010',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/5.jpg',
Agent: {
Name: 'John Heart',
Phone: '(213) 555-9392',
Picture: '../../../../images/employees/01.png',
},
},
{
ID: '6',
Favorite: false,
Address: '8512 Tanglewood Cir',
City: 'Reform',
State: 'AL',
ZipCode: '35487',
Beds: '3',
Baths: '2',
HouseSize: 5600,
LotSize: '0.2',
Price: 250000,
Coordinates: '33.3794,-87.9785788',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Formal dining room, Built-in bookcases in family room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Marble/Stone flooring in kitchen, Pantry, Formal living room, Front living room, Ceiling fan in master bedroom, Master bedroom downstairs, Master bedroom separate from other, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 11X15, 3rd bedroom: 11X14, Alarm system owned, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Double built-in electric ovens, Drapes, Electric cooktop, Marble/Stone floors, Window Coverings Throughout, Wine refrigerator',
YearBuilt: '2011',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/6.jpg',
Agent: {
Name: 'Olivia Peyton',
Phone: '(310) 555-2728',
Picture: '../../../../images/employees/09.png',
},
},
{
ID: '7',
Favorite: false,
Address: '7121 Bailey St',
City: 'Worcester',
State: 'MA',
ZipCode: '01605',
Beds: '4',
Baths: '3',
HouseSize: 6900,
LotSize: '2.1',
Price: 555000,
Coordinates: '42.2797,-71.8746388',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 1st floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Kitchen island, Recessed lighting in kitchen, Tile countertops in kitchen, Walk-in pantry, Entry foyer, Formal living room, Front living room, Dressing room in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Walk-in closet in master bedroom, 2nd bedroom: 14x16, 3rd bedroom: 12x13, 4th Bedroom: 13x14, Carpet, Double built-in electric ovens, Drywall, Gas cooktop, Manmade wood or laminate floors, Marble/Stone floors, Water conditioner loope',
YearBuilt: '2008',
Type: '0',
Status: '1',
Image: '../../../../images/gallery/7.jpg',
Agent: {
Name: 'Robert Reagan',
Phone: '(818) 555-2387',
Picture: '../../../../images/employees/03.png',
},
},
{
ID: '8',
Favorite: false,
Address: '620201 Plymouth Rd',
City: 'Detroit',
State: 'MI',
ZipCode: ' 48224',
Beds: '4',
Baths: '4',
HouseSize: 7840,
LotSize: '0.33',
Price: 610000,
Coordinates: '42.3716299,-83.2572188',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Formal dining room, 2+ family rooms, Separate family room, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Walk-in pantry, Entry foyer, Formal living room, Rear living room, Vaulted ceiling in living room, Ceiling fan in master bedroom, Master bedroom downstairs, Walk-in closet in master bedroom, 2nd bedroom: 12x15, 3rd bedroom: 12x15, 4th Bedroom: 12x15, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Electric cooktop, Shutters, Skylight(s), Water conditioner owned, Water filtering system, Window coverings partial',
YearBuilt: '2010',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/8.jpg',
Agent: {
Name: 'Greta Sims',
Phone: '(818) 555-6546',
Picture: '../../../../images/employees/04.png',
},
},
{
ID: '9',
Favorite: false,
Address: '1198 Theresa Cir',
City: 'Whitinsville',
State: 'MA',
ZipCode: '01582',
Beds: '4',
Baths: '3',
HouseSize: 4990,
LotSize: '0.8',
Price: 320000,
Coordinates: '42.1072,-71.6928888',
Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 1st floor, 1/2 bath downstairs, Formal dining room, 2+ family rooms, Built-in bookcases in family room, Breakfast Bar/Counter, Granite countertops in kitchen, Kitchen island, Tile flooring in kitchen, Walk-in pantry, Entry foyer, Formal living room, Built-in bookcases in master bedroom, Built-in entertainment center in master bedroom, Ceiling fan in master bedroom, Dressing room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 13x12, 3rd bedroom: 12x12, 4th Bedroom: 13x12, Alarm system rented, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Double built-in gas ovens, Tile floors, Window Coverings Throughout',
YearBuilt: '2011',
Type: '0',
Status: '0',
Image: '../../../../images/gallery/9.jpg',
Agent: {
Name: 'John Heart',
Phone: '(213) 555-9392',
Picture: '../../../../images/employees/01.png',
},
},
];
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.5/cjs',
'devextreme-react': 'npm:devextreme-react@23.1.5',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.1/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.48/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Overview

DevExtreme Dialog and Notification Angular components help a user interact with your application. They provide intuitive UI, adaptive design, and customization flexibility. As Angular components, they support native features of the framework: AOT compilation, declarative configuration, TypeScript compile-time checking, and more.

Backend API
<div class="images"> <div *ngFor="let house of houses"> <div (click)="showHouse(house)" class="item-content"> <img alt="{{ house.Address }}" src="{{ house.Image }}" /> <div class="item-options"> <div> <div class="address">{{ house.Address }}</div> <div class="price large-text">{{ house.Price | currency : "USD" : "symbol" : "1.0-0" }}</div> <div class="agent"> <div id="house{{ house.ID }}"> <img alt="Listing agent" src="../../../../images/icon-agent.svg" /> Listing agent </div> </div> </div> </div> <dx-popover target="#house{{ house.ID }}" showEvent="mouseenter" hideEvent="mouseleave" contentTemplate="popoverContent" [width]="260" > <dxo-position at="bottom" my="top" offset="0 2" collision="fit flip"> </dxo-position> <div *dxTemplate="let data of 'popoverContent'"> <div class="agent-details"> <img alt="{{ house.Agent.Name }}" src="{{ house.Agent.Picture }}" /> <div> <div class="name large-text">{{ house.Agent.Name }}</div> <div class="phone">Tel: {{ house.Agent.Phone }}</div> </div> </div> </div> </dx-popover> </div> </div> <dx-popup [width]="660" [height]="540" [showTitle]="true" [title]="currentHouse.Address" [dragEnabled]="false" [hideOnOutsideClick]="true" [(visible)]="popupVisible" [showCloseButton]="true" > <div *dxTemplate="let data of 'content'"> <div class="popup-property-details"> <div class="large-text">{{ currentHouse.Price | currency : "USD" : "symbol" : "1.0-0" }}</div> <div class="opacity" >{{ currentHouse.Address }}, {{ currentHouse.City }}, {{ currentHouse.State }}</div > <dx-button class="favorites" icon="favorites" [text]=" currentHouse.Favorite ? REMOVE_FROM_FAVORITES : ADD_TO_FAVORITES " [width]="260" [height]="44" (onClick)="changeFavoriteState($event)" > </dx-button> <div class="images"> <img alt="{{ currentHouse.Address }}" src="{{ currentHouse.Image }}" /> <img alt="{{ currentHouse.Address }}" src="{{ currentHouse.Image.replace('.jpg', 'b.jpg') }}" /> </div> <div>{{ currentHouse.Features }}</div> </div> </div> </dx-popup> </div>
import { NgModule, Component, enableProdMode } from '@angular/core'; import { DecimalPipe } from '@angular/common'; import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { DxTemplateModule, DxButtonModule, DxPopupModule, DxPopoverModule, } from 'devextreme-angular'; import notify from 'devextreme/ui/notify'; import { Service, House, Agent } from './app.service'; if (!/localhost/.test(document.location.host)) { enableProdMode(); } @Component({ selector: 'demo-app', templateUrl: 'app/app.component.html', styleUrls: ['app/app.component.css'], providers: [Service], }) export class AppComponent { houses: House[]; currentHouse: House; popupVisible = false; ADD_TO_FAVORITES = 'Add to Favorites'; REMOVE_FROM_FAVORITES = 'Remove from Favorites'; constructor(service: Service) { this.houses = service.getHouses(); this.currentHouse = this.houses[0]; } showHouse(house: House) { this.currentHouse = house; this.popupVisible = true; } changeFavoriteState() { const favoriteState = !this.currentHouse.Favorite; const message = `This item has been ${ favoriteState ? 'added to' : 'removed from' } the Favorites list!`; this.currentHouse.Favorite = favoriteState; notify({ message, width: 450, }, favoriteState ? 'success' : 'error', 2000); } } @NgModule({ imports: [ BrowserModule, BrowserTransferStateModule, DxTemplateModule, DxButtonModule, DxPopupModule, DxPopoverModule, ], declarations: [AppComponent], bootstrap: [AppComponent], }) export class AppModule { } platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .large-text { font-size: 24px; color: #ff6a50; } ::ng-deep .opacity { opacity: 0.5; } ::ng-deep .images { font-size: 0; } ::ng-deep .images > div { display: inline-block; width: 33.3%; vertical-align: top; } ::ng-deep .images .item-content { position: relative; margin: 5px; color: #fff; cursor: pointer; } ::ng-deep .images .item-content > img { width: 100%; } ::ng-deep .item-content .item-options { position: absolute; top: 0; left: 0; height: 100%; width: 100%; } ::ng-deep .images .item-content:hover > .item-options { box-shadow: inset 0 0 0 2px #f05b41; } ::ng-deep .item-content .item-options > div { position: absolute; bottom: 0; width: 100%; height: 64px; padding-top: 4px; background-color: rgba(19, 32, 51, 0.8); z-index: 1; -webkit-box-sizing: border-box; -moz-box-sizing: border-box; box-sizing: border-box; border-left: 2px solid transparent; border-right: 2px solid transparent; } ::ng-deep .images .item-content:hover > .item-options > div { border-bottom: 2px solid #f05b41; border-left: 2px solid #f05b41; border-right: 2px solid #f05b41; } ::ng-deep .item-content .item-options .address, ::ng-deep .item-content .item-options .price { max-width: 70%; padding-left: 8px; } ::ng-deep .item-content .item-options .address { font-size: 14px; } ::ng-deep .item-content .item-options .agent { font-size: 12px; width: 60px; position: absolute; right: -2px; top: 0; bottom: 0; text-align: center; border-left: 1px solid rgba(255, 255, 255, 0.4); line-height: 13px; } ::ng-deep .item-content .item-options .agent > div:hover { color: #f05b41; } ::ng-deep .item-content .item-options .agent img { display: block; width: 13px; height: 16px; margin: 8px auto 2px; } ::ng-deep .agent-details > img, .agent-details > div { display: inline-block; vertical-align: top; line-height: 26px; } ::ng-deep .agent-details > img { width: 40px; margin-right: 10px; } ::ng-deep .agent-details .phone { font-size: 18px; } ::ng-deep .popup-property-details { overflow: hidden; position: relative; } ::ng-deep .popup-property-details .images { width: 700px; } ::ng-deep .popup-property-details img { height: 205px; margin: 10px 10px 10px 0; } ::ng-deep .dx-button.favorites { background-color: #f05b41; color: #fff; position: absolute; top: 5px; right: 0; } ::ng-deep .dx-button.favorites .dx-icon { color: #fff; }
import { Injectable } from '@angular/core'; export class Agent { ID: number; Name: string; Phone: string; Picture: string; } export class House { ID: number; Address: string; City: string; State: string; ZipCode: string; Price: number; Image: string; Features: string; Favorite?: boolean; Agent: Agent; } const houses: House[] = [{ ID: 1, Favorite: false, Address: '652 Avonwick Gate', City: 'Toronto', State: 'ON', ZipCode: 'M3A25', Price: 780000, Image: '../../../../images/gallery/1.jpg', Features: 'Dishwasher, Disposal, Separate laundry room, 3/4 bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Hardwood flooring in kitchen, Kitchen island, Solid surface countertops in kitchen, Entry foyer, Front living room, Ceiling fan in master bedroom, Master bedroom separate from other, Mirrored door closet in master bedroom, 2nd bedroom: 11x13, 3rd bedroom: 11x14, 4th Bedroom: 18x13, Alarm system owned, Built-in microwave, Carpet, Ceiling fan(s), Convection oven, Double built-in gas ovens, Gas cooktop, Gas stove, Marble/Stone floors', Agent: { ID: 1, Name: 'John Heart', Phone: '(213) 555-9392', Picture: '../../../../images/employees/01.png', }, }, { ID: 2, Favorite: false, Address: '82649 Topeka St', City: 'Riverbank', State: 'CA', ZipCode: '95360', Price: 1750000, Image: '../../../../images/gallery/2.jpg', Features: 'Dishwasher, Disposal, Separate laundry room, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Pantry, Walk-in pantry, Entry foyer, Formal living room, Rear living room, Vaulted ceiling in living room, Balcony in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 13X20, 3rd bedroom: 13X17, 4th Bedroom: 13X18, 5th Bedroom: 14X16, Alarm system owned, Blinds, Built-in electric oven, Built-in microwave, Carpet, Ceiling fan(s), Gas cooktop, Intercom system, Marble/Stone floors, Water conditioner owned, Water filtering system, Window Coverings Throughout', Agent: { ID: 2, Name: 'Olivia Peyton', Phone: '(310) 555-2728', Picture: '../../../../images/employees/09.png', }, }, { ID: 3, Favorite: false, Address: '328 S Kerema Ave', City: 'Milford', State: 'CT', ZipCode: '06465', Price: 350000, Image: '../../../../images/gallery/3.jpg', Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 2nd floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Wet bar in family room, Breakfast nook (eating area), Garden window in kitchen, Granite countertops in kitchen, Kitchen island, Marble/Stone flooring in kitchen, Pantry, Formal living room, Front living room, Master bedroom separate from other, Master bedroom upstairs, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 16x12, 3rd bedroom: 13x16, 4th Bedroom: 18x12, Alarm system owned, Built-in microwave, Carpet, Ceiling fan(s), Double built-in electric ovens, Gas cooktop, Marble/Stone floors', Agent: { ID: 3, Name: 'Robert Reagan', Phone: '(818) 555-2387', Picture: '../../../../images/employees/03.png', }, }, { ID: 4, Favorite: false, Address: '5119 Beryl Dr', City: 'San Antonio', State: 'TX', ZipCode: '78212', Price: 455000, Image: '../../../../images/gallery/4.jpg', Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Living/Dining room combo, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Recessed lighting in kitchen, Tile flooring in kitchen, Walk-in pantry, Formal living room, Front living room, Ceiling fan in master bedroom, Master bedroom downstairs, Walk-in closet in master bedroom, 2nd bedroom: 15x13, 3rd bedroom: 12x12, 4th Bedroom: 14x12, Alarm system owned, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Central vacuum, Convection oven, Double built-in electric ovens, Electric cooktop, Intercom system, Tile floors', Agent: { ID: 4, Name: 'Greta Sims', Phone: '(818) 555-6546', Picture: '../../../../images/employees/04.png', }, }, { ID: 5, Favorite: false, Address: '61207 16th St N', City: 'Moorhead', State: 'MN', ZipCode: '56564', Price: 1700000, Image: '../../../../images/gallery/5.jpg', Features: 'Dishwasher, Disposal, Separate laundry room, Washer/Dryer on 1st floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Formal living room, Rear living room, Sunken living room, Vaulted ceiling in living room, Balcony in master bedroom, Ceiling fan in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Walk-in closet in master bedroom, 2nd bedroom: 16X17, 3rd bedroom: 14X16, 4th Bedroom: 13X13, 5th Bedroom: 12X12, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Central vacuum, Double built-in electric ovens, Gas cooktop, Marble/Stone floors, Pot shelves, Water conditioner owned, Water filtering system, Window Coverings Throughout', Agent: { ID: 1, Name: 'John Heart', Phone: '(213) 555-9392', Picture: '../../../../images/employees/01.png', }, }, { ID: 6, Favorite: false, Address: '8512 Tanglewood Cir', City: 'Reform', State: 'AL', ZipCode: '35487', Price: 250000, Image: '../../../../images/gallery/6.jpg', Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Formal dining room, Built-in bookcases in family room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Marble/Stone flooring in kitchen, Pantry, Formal living room, Front living room, Ceiling fan in master bedroom, Master bedroom downstairs, Master bedroom separate from other, Sitting room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 11X15, 3rd bedroom: 11X14, Alarm system owned, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Double built-in electric ovens, Drapes, Electric cooktop, Marble/Stone floors, Window Coverings Throughout, Wine refrigerator', Agent: { ID: 2, Name: 'Olivia Peyton', Phone: '(310) 555-2728', Picture: '../../../../images/employees/09.png', }, }, { ID: 7, Favorite: false, Address: '7121 Bailey St', City: 'Worcester', State: 'MA', ZipCode: '01605', Price: 555000, Image: '../../../../images/gallery/7.jpg', Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 1st floor, Full bath downstairs, Formal dining room, Downstairs family room, Separate family room, Breakfast Bar/Counter, Breakfast nook (eating area), Kitchen island, Recessed lighting in kitchen, Tile countertops in kitchen, Walk-in pantry, Entry foyer, Formal living room, Front living room, Dressing room in master bedroom, Master bedroom separate from other, Master bedroom upstairs, Walk-in closet in master bedroom, 2nd bedroom: 14x16, 3rd bedroom: 12x13, 4th Bedroom: 13x14, Carpet, Double built-in electric ovens, Drywall, Gas cooktop, Manmade wood or laminate floors, Marble/Stone floors, Water conditioner loope', Agent: { ID: 3, Name: 'Robert Reagan', Phone: '(818) 555-2387', Picture: '../../../../images/employees/03.png', }, }, { ID: 8, Favorite: false, Address: '620201 Plymouth Rd', City: 'Detroit', State: 'MI', ZipCode: ' 48224', Price: 610000, Image: '../../../../images/gallery/8.jpg', Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Full bath downstairs, Formal dining room, 2+ family rooms, Separate family room, Breakfast nook (eating area), Granite countertops in kitchen, Kitchen custom cabinets, Kitchen island, Walk-in pantry, Entry foyer, Formal living room, Rear living room, Vaulted ceiling in living room, Ceiling fan in master bedroom, Master bedroom downstairs, Walk-in closet in master bedroom, 2nd bedroom: 12x15, 3rd bedroom: 12x15, 4th Bedroom: 12x15, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Electric cooktop, Shutters, Skylight(s), Water conditioner owned, Water filtering system, Window coverings partial', Agent: { ID: 4, Name: 'Greta Sims', Phone: '(818) 555-6546', Picture: '../../../../images/employees/04.png', }, }, { ID: 9, Favorite: false, Address: '1198 Theresa Cir', City: 'Whitinsville', State: 'MA', ZipCode: '01582', Price: 320000, Image: '../../../../images/gallery/9.jpg', Features: 'Dishwasher, Disposal, Refrigerator, Separate laundry room, Washer/Dryer on 1st floor, 1/2 bath downstairs, Formal dining room, 2+ family rooms, Built-in bookcases in family room, Breakfast Bar/Counter, Granite countertops in kitchen, Kitchen island, Tile flooring in kitchen, Walk-in pantry, Entry foyer, Formal living room, Built-in bookcases in master bedroom, Built-in entertainment center in master bedroom, Ceiling fan in master bedroom, Dressing room in master bedroom, Walk-in closet in master bedroom, 2nd bedroom: 13x12, 3rd bedroom: 12x12, 4th Bedroom: 13x12, Alarm system rented, Blinds, Built-in microwave, Carpet, Ceiling fan(s), Double built-in gas ovens, Tile floors, Window Coverings Throughout', Agent: { ID: 1, Name: 'John Heart', Phone: '(213) 555-9392', Picture: '../../../../images/employees/01.png', }, }, ]; @Injectable() export class Service { getHouses(): House[] { return houses; } }
// In real applications, you should not transpile code in the browser. // You can see how to create your own application with Angular and DevExtreme here: // https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/ window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, }, meta: { 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, map: { 'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', '@angular/core': 'npm:@angular/core@12.2.17', '@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17', '@angular/forms': 'npm:@angular/forms@12.2.17', '@angular/common': 'npm:@angular/common@12.2.17', '@angular/compiler': 'npm:@angular/compiler@12.2.17', 'tslib': 'npm:tslib@2.6.2/tslib.js', 'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js', 'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.5/cjs', 'devextreme/bundles/dx.all': 'npm:devextreme@23.2.5/bundles/dx.all.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.51', 'devextreme-angular': 'npm:devextreme-angular@23.2.5', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'app': { main: './app.component.ts', defaultExtension: 'ts', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, 'rxjs': { defaultExtension: 'js', }, 'rxjs/operators': { defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', 'npm:@angular/*/package.json', 'npm:@angular/common@12.2.17/*/package.json', 'npm:rxjs@7.5.3/package.json', 'npm:rxjs@7.5.3/operators/package.json', 'npm:devextreme-angular@23.2.5/*/package.json', 'npm:devextreme-angular@23.2.5/ui/*/package.json', 'npm:devextreme-angular@23.2.5/package.json', 'npm:devexpress-diagram@2.2.5/package.json', 'npm:devexpress-gantt@4.1.51/package.json', ], }; System.config(window.config);
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.5/css/dx.light.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script> <script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script src="config.js"></script> <script> System.import("app").catch(console.error.bind(console)); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <demo-app>Loading...</demo-app> </div> </body> </html>